##############################################################################
#
# Copyright (c) 2002 Nik Kim <fafhrd@mindless.com> All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.CMFCorePermissions import AddPortalContent

# install formulator patchs
import frmpatch

from Products.Formulator.FieldRegistry import FieldRegistry
import FSForm, FakeField
FieldRegistry.registerField(FakeField.FakeField, 'www/StringField.gif')
utils.registerIcon(FSForm.FSForm, 'dtml/Form.gif', globals())

import CMFForm, MailStorage, CMFFieldTypes

contentClasses = (
    CMFForm.CMFForm, MailStorage.MailStorage,) + tuple(CMFFieldTypes.klasses)

contentConstructors = (
    CMFForm.manage_addFormulatorForm,
    MailStorage.manage_addMailStorage,
    ) + tuple(CMFFieldTypes.factories)

factory_type_information = (
    CMFForm.factory_type_information +
    MailStorage.factory_type_information
    ) + tuple(CMFFieldTypes.ftis)

factory_type_information[0]['allowed_content_types'] = [
    fti['id'] for fti in factory_type_information[1:]]
factory_type_information[0]['allowed_content_types'].append('Document')

import sys
this_module = sys.modules[__name__]
formulator_globals = globals()

z_bases = utils.initializeBasesPhase1( contentClasses, this_module )

registerDirectory('skins', globals())

def initialize( context ):

    utils.initializeBasesPhase2( z_bases, context )
    utils.ContentInit( 'CMFFormulator Content', content_types=contentClasses,
                       permission=AddPortalContent,
                       extra_constructors=contentConstructors,
                       fti=factory_type_information
                       ).initialize( context )
